/* about.cpp --

   This file is part of the "PE Maker".

   Copyright (C) 2005-2006 Ashkbiz Danehkar
   All Rights Reserved.

   "PE Maker" library are free software; you can redistribute them
   and/or modify them under the terms of the GNU General Public License as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYRIGHT.TXT.
   If not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   yodap's Forum:
   http://yodap.sourceforge.net/forum/

   yodap's Site:
   http://yodap.has.it
   http://yodap.cjb.net
   http://yodap.sourceforge.net

   Ashkbiz Danehkar
   <ashkbiz@yahoo.com>
*/
#include "stdafx.h"
#include "About.h"
//--------------------------------------------
class CAboutForm
{
private:
	//-----------------------------------------
public:
	//-----------------------------------------
	BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
	void OnCommand (HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
public:
	//-----------------------------------------
	CAboutForm();
	~CAboutForm();
	//-----------------------------------------
};
//--------------------------------------------
CAboutForm *AboutForm;
//--------------------------------------------
//***************************************************************************
LRESULT CALLBACK About(HWND hDlg,UINT uiMsg,WPARAM wParam,LPARAM lParam)
{
	AboutForm=new (CAboutForm);
	switch (uiMsg) 
	{
	HANDLE_MSG(hDlg, WM_INITDIALOG,	AboutForm->OnInitDialog);
	HANDLE_MSG(hDlg, WM_COMMAND,	AboutForm->OnCommand);
	}
	return 0;
}
//***************************************************************************
CAboutForm::CAboutForm()
{
}
//***************************************************************************
CAboutForm::~CAboutForm()
{
}
/****************************************************************************
*								OnInitDialog
****************************************************************************/
BOOL CAboutForm::OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
	return TRUE;
}

/****************************************************************************
*								OnCommand
*
*  hwnd			Handle of window to which this message applies
*  id			Specifies the identifier of the menu item, 
*				control, or accelerator.
*  hwndCtl		Handle of the control sending the message if the message
*				is from a control, otherwise, this parameter is NULL. 
*  codeNotify	Specifies the notification code if the message is from 
*				a control.
*				This parameter is 1 when the message is from an 
*				accelerator.
*				This parameter is 0 when the message is from a menu.
****************************************************************************/
void CAboutForm::OnCommand (HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	switch (id) 
	{	/* id */
		case IDOK:
		case IDCANCEL:
			EndDialog(hwnd,(INT_PTR) &codeNotify);
			break;
		case IDC_WEB:
			WinExec("Explorer http://yodap.has.it/", SW_SHOWMAXIMIZED);
			break;
	}/* id */
}
